/*--------------------------------------------------------------------------*/
/*                                                                          */
/*                                                                          */
/*      ------------         Bit-Bucket Software, Co.                       */
/*      \ 10001101 /         Writers and Distributors of                    */
/*       \ 011110 /          Freely Available<tm> Software.                 */
/*        \ 1011 /                                                          */
/*         ------                                                           */
/*                                                                          */
/*              (C) Copyright 1987-96, Bit Bucket Software Co.              */
/*                                                                          */
/*                                                                          */
/*                                                                          */
/*                 Message definitions used in BinkleyTerm                  */
/*                                                                          */
/*                                                                          */
/*    For complete  details  of the licensing restrictions, please refer    */
/*    to the License  agreement,  which  is published in its entirety in    */
/*    the MAKEFILE and BT.C, and also contained in the file LICENSE.260.    */
/*                                                                          */
/*    USE  OF THIS FILE IS SUBJECT TO THE  RESTRICTIONS CONTAINED IN THE    */
/*    BINKLEYTERM  LICENSING  AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF    */
/*    THIS  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES,  OR IF YOU DO    */
/*    NOT HAVE THESE FILES,  YOU  SHOULD  IMMEDIATELY CONTACT BIT BUCKET    */
/*    SOFTWARE CO.  AT ONE OF THE  ADDRESSES  LISTED BELOW.  IN NO EVENT    */
/*    SHOULD YOU  PROCEED TO USE THIS FILE  WITHOUT HAVING  ACCEPTED THE    */
/*    TERMS  OF  THE  BINKLEYTERM  LICENSING  AGREEMENT,  OR  SUCH OTHER    */
/*    AGREEMENT AS YOU ARE ABLE TO REACH WITH BIT BUCKET SOFTWARE, CO.      */
/*                                                                          */
/*                                                                          */
/* You can contact Bit Bucket Software Co. at any one of the following      */
/* addresses:                                                               */
/*                                                                          */
/* Bit Bucket Software Co.        FidoNet  1:104/501, 1:343/491             */
/* P.O. Box 460398                AlterNet 7:42/1491                        */
/* Aurora, CO 80046               BBS-Net  86:2030/1                        */
/*                                Internet f491.n343.z1.fidonet.org         */
/*                                                                          */
/* Please feel free to contact us at any time to share your comments about  */
/* our software and/or licensing policies.                                  */
/*                                                                          */
/*--------------------------------------------------------------------------*/

/* Make this easier to change in other environments (e.g. PM, Windows) */

#define MSG_TXT(m)               msgtxt[m]

#define M_DIALING_SCRIPT         0
#define M_NOOPEN_SCRIPT          1
#define M_MASTER_SCRIPT_TIMER    2
#define M_SCRIPT_FAILED          3
#define M_NO_BREAK               4
#define M_TOO_MANY_LABELS        5
#define M_MACRO_NUMBER           6
#define M_OUT_OF_RANGE           7
#define M_SHELL_NUMBER           8
#define M_ILLEGAL_ZONE           9
#define M_REQUESTS_ALLOWED       10
#define M_BAD_LOGLEVEL           11
#define M_BAD_MAXPORT            12
#define M_ILLEGAL_PORT           13
#define M_ILLEGAL_CARRIER        14
#define M_KEY                    15
#define M_CALL                   16
#define M_UNKNOWN_LINE           17
#define M_BAD_DIR                18
#define M_FAIL_EXEC              19
#define M_PRESS_ESCAPE           20
#define M_NO_BBS                 21
#define M_NOTHING_TO_SEND        22
#define M_CONNECT_ABORTED        23
#define M_MODEM_HANGUP           24
#define M_NO_OUT_REQUESTS        25
#define M_OUT_REQUESTS           26
#define M_END_OUT_REQUESTS       27
#define M_FREQ_DECLINED          28
#define M_ADDRESS                29
#define M_INTRO                  30
#define M_NOBODY_HOME            31
#define M_NO_CARRIER             32
#define M_PROTECTED_SESSION      33
#define M_PWD_ERROR              34
#define M_CALLED                 35
#define M_WAZOO_METHOD           36
#define M_WAZOO_END              37
#define M_PACKET_MSG             38
#define M_OPEN_MSG               39
#define M_KBD_MSG                40
#define M_TRUNC_MSG              41
#define M_RENAME_MSG             42
#define M_DEVICE_MSG             43
#define M_FUBAR_MSG              44
#define M_UNLINKING_MSG          45
#define M_CAN_MSG                46
#define M_NO_CTL_FILE            47
#define M_FOSSIL_GONE            48
#define M_NO_LOGFILE             49
#define M_FOSSIL_TYPE            50
#define M_FOSSIL_REV3            51
#define M_STARTING_EVENT         52
#define M_EVENT_EXIT             53
#define M_CLEAN_PACK             54
#define M_AFTER_CLEAN_PACK       55
#define M_DATE_PROBLEM           56
#define M_BBS_EXIT               57
#define M_BBS_SPAWN              58
#define M_BBS_RETURN             59
#define M_EXT_MAIL               60
#define M_SETTING_BAUD           61
#define M_REMOTE_USES            62
#define M_VERSION                63
#define M_PROGRAM                64
#define M_SEND_FALLBACK          65
#define M_REFUSING_IN_FREQ       66
#define M_TOO_LONG               67
#define M_0001_END               68
#define M_RECV_FALLBACK          69
#define M_GIVING_MAIL            70
#define M_REFUSE_PICKUP          71
#define M_MEM_ERROR              72
#define M_OUTBOUND               73
#define M_FILE_ATTACHES          74
#define M_MAKING_FREQ            75
#define M_END_OF                 76
#define M_RECV_MAIL              77
#define M_NO_PICKUP              78
#define M_INBOUND                79
#define M_MAIL_PACKET            80
#define M_PWD_ERR_ASSUMED        81
#define M_CANT_RENAME_MAIL       82
#define M_MAIL_PACKET_RENAMED    83
#define M_NO_PROTOCOL            84
#define M_DUP_PROTOCOL           85
#define M_PROCESSING_NODE        86
#define M_NO_ADDRESS             87
#define M_NUISANCE_CALLER        88
#define M_NO_BOSS                89
#define M_UNABLE_TO_OPEN         90
#define M_NODELIST_MEM           91
#define M_NODELIST_READ_ERR      92
#define M_NODELIST_SEEK_ERR      93
#define M_NODELIST_REC_ERR       94
#define M_FILE_REQUESTS          95
#define M_MATCHING_FILES         96
#define M_BAD_BARK               97
#define M_BAD_CRC                98
#define M_MISCONFIGURED          99
#define M_EVENT_WAITING          100
#define M_INCOMING_CALL          101
#define M_DYNAMIC_EVENT          102
#define M_EXIT_REQUEST           103
#define M_FUNCTION_KEY           104
#define M_DISABLE_MODEM          105
#define M_BEGIN_MESSAGE_READER   106
#define M_END_MESSAGE_READER     107
#define M_ENABLE_MODEM           108
#define M_NO_MESSAGE_READER      109
#define M_NO_GET                 110
#define M_NO_KILL                111
#define M_POLL_MODE              112
#define M_POLL_COMPLETED         113
#define M_NO_SEND                114
#define M_ENTER_TERMINAL_MODE    115
#define M_POLLING_BOSS           116
#define M_KEYBOARD_SHELL         117
#define M_END_KEYBOARD_SHELL     118
#define M_NO_KEYBOARD_SHELL      119
#define M_JUNK_CHARACTER         120
#define M_SHELLING               121
#define M_TYPE_EXIT              122
#define M_BINKLEY_BACK           123
#define M_NO_CALLS_NOW           124
#define M_IMMEDIATE_CALL         125
#define M_ENTER_NET_NODE         126
#define M_CURRENTLY_POLLING      127
#define M_READY_INIT             128
#define M_READY_WAITING          129
#define M_READY_DIALING          130
#define M_READY_HANGUP           131
#define M_READY_CONNECT          132
#define M_DIALING_NUMBER         133
#define M_NO_END_MIDNIGHT        134
#define M_INVALID_START          135
#define M_INVALID_END            136
#define M_INVALID_AVGWAIT        137
#define M_BAD_ERRORLEVEL         138
#define M_BAD_TRIES              139
#define M_INDECIPHERABLE         140
#define M_BAD_DAY                141
#define M_NOTHING_IN_OUTBOUND    142
#define M_OUTBOUND_HEADER        143
#define M_INSUFFICIENT_DATA      144
#define M_END_OF_ATTEMPT         145
#define M_STILL_HAVE_MAIL        146
#define M_EXIT_COMPRESSED        147
#define M_EXIT_AFTER_EXTENT      148
#define M_EXIT_AFTER_MAIL        149
#define M_AFTERMAIL              150
#define M_OK_AFTERMAIL           151
#define M_SETTING                152
#define M_INITIAL_SPEED          153
#define M_INTRO_END              154
#define M_MULTI_TASKER           155
#define M_CURRENT_SETTINGS       156
#define M_TODAY_GLANCE           157
#define M_PENDING_OUTBOUND       158
#define M_INITIALIZING_SYSTEM    159
#define M_RECENT_ACTIVITY        160
#define M_TRANSFER_STATUS        161
#define M_EVENT_COLON            162
#define M_PORT_COLON             163
#define M_STATUS_INIT            164
#define M_BBS_MAIL               165
#define M_CALLS_OUT              166
#define M_GOOD_COST              167
#define M_FILES_IO               168
#define M_LAST                   169
#define M_ALTF10                 170
#define M_NODE_COLON             171
#define M_PASSWORD_OVERRIDE      172
#define M_ZMODEM_STARTED         173
#define M_ZMODEM_FINISHED        174
#define M_BINK_NOW_AT            175
#define M_PHONE_OR_NODE          176
#define M_NO_DROP_DTR            177
#define M_WELCOME_BACK           178
#define M_INPUT_LOGFILE          179
#define M_MAILER_MODE            180
#define M_MANUAL_MODE            181
#define M_BINK_NOW_USING         182
#define M_READY_TO_SEND          183
#define M_WHICH_PROTOCOL         184
#define M_READY_TO_RECEIVE       185
#define M_SENDING_BREAK          186
#define M_DONE                   187
#define M_YOU_ARE_USING          188
#define M_DONT_KNOW_PROTO        189
#define M_FILE_TO_SEND           190
#define M_CHOOSE                 191
#define M_FILE_TO_RECEIVE        192
#define M_LOG_CLOSED             193
#define M_LOG_NOT_OPEN           194
#define M_LOG_OPEN               195
#define M_END_OF_CONNECT         196
#define M_SWITCHING_BACK         197
#define M_POLLING_COLON          198
#define M_GET_FILE               199
#define M_ADDRESS_TO_GET_FROM    200
#define M_PASSWORD_TO_USE        201
#define M_ARE_YOU_SURE           202
#define M_YES                    203
#define M_NO                     204
#define M_SEND_FILE              205
#define M_ADDRESS_TO_SEND_TO     206
#define M_KILL_MAIL              207
#define M_ADDRESS_TO_KILL        208
#define M_KILL_ALL_MAIL          209
#define M_DRATS                  210
#define M_HE_HUNG_UP             211
#define M_CORRECTED_ERRORS       212
#define M_FILE_SENT              213
#define M_SYNCHRONIZING          214
#define M_TEMP_NOT_OPEN          215
#define M_ALREADY_HAVE           216
#define M_SYNCHRONIZING_EOF      217
#define M_SYNCHRONIZING_OFFSET   218
#define M_FILE_RECEIVED          219
#define M_ORIGINAL_NAME_BAD      220
#define M_UNEXPECTED_EOF         221
#define M_REMOTE_SYSTEM          222
#define M_UNKNOWN_MAILER         223
#define M_SYSTEM_INITIALIZING    224
#define M_UNRECOGNIZED_OPTION    225
#define M_THANKS                 226
#define M_ANOTHER_FINE_PRODUCT   227
#define M_REMOTE_REFUSED         228
#define M_ERROR                  229
#define M_CANT                   230
#define M_CPS_MESSAGE            231
#define M_COMPRESSED_MAIL        232
#define M_NET_FILE               233
#define M_ELAPSED                234
#define M_TROUBLE                235
#define M_RESENDING_FROM         236
#define M_SEND_MSG               237
#define M_UPDATE                 238
#define M_FILE                   239
#define M_REQUEST                240
#define M_EXECUTING              241
#define M_CARRIER_REQUEST_ERR    242
#define M_FREQ_LIMIT             243
#define M_EVENT_OVERRUN          244
#define M_NO_AVAIL               245
#define M_NO_ABOUT               246
#define M_OKFILE_ERR             247
#define M_FREQ_PW_ERR            248
#define M_RECEIVE_MSG            249
#define M_TIMEOUT                250
#define M_CHECKSUM               251
#define M_CRC_MSG                252
#define M_JUNK_BLOCK             253
#define M_ON_BLOCK               254
#define M_FIND_MSG               255
#define M_READ_MSG               256
#define M_SEEK_MSG               257
#define M_SHRT_MSG               258
#define M_CLOSE_MSG              259
#define M_UNLINK_MSG             260
#define M_WRITE_MSG              261
#define M_SKIP_MSG               262
#define M_PHONE_HELP             263
#define M_PHONE_HELP2            264
#define M_LAST_SET               265
#define M_CURRENT_PHONES         266
#define M_INPUT_COMMAND          267
#define M_ELEMENT_CHOSEN         268
#define M_CURRENTLY_CONTAINS     269
#define M_PHONE_HELP3            270
#define M_PHONE_HELP4            271
#define M_SET_READ_ERROR         272
#define M_SET_CLOSE_ERR          273
#define M_SET_LOADED             274
#define M_SET_WRITE_ERROR        275
#define M_SET_SAVED              276
#define M_PRESS_ENTER            277
#define M_STARTING_SCAN          278
#define M_CONNECTED_TO_ITEM      279
#define M_DEBRIS                 280
#define M_LONG_PACKET            281
#define M_Z_IGNORING             282
#define M_OUT_OF_DISK_SPACE      283
#define M_RECEIVING              284
#define M_Z_INITRECV             285
#define M_BAD_POS                286
#define M_Z_RZ                   287
#define M_J_BAD_PACKET           288
#define M_SEND                   289
#define M_RECV                   290
#define M_OTHER_DIED             291
#define M_GOING_ONE_WAY          292
#define M_REFUSING               293
#define M_UNKNOWN_PACKET         294
#define M_SESSION_ABORT          295
#define M_SENDING                296
#define M_NO_LENGTH              297
#define M_FINISHED_PART          298
#define M_SAVING_PART            299
#define M_REMOTE_CANT_FREQ       300
#define M_MAIN_HELP              301	/* 11 messages total */
#define M_MACRO_HELP             312
#define M_PRESS_ANYKEY           313
#define M_MAILER_HELP            314	/* 15 messages total */
#define M_BLANK_HELP             329
#define M_EDITOR_HELP            330
#define M_SHELL_HELP             331
#define M_DRIVER_DEAD_1          332
#define M_DRIVER_DEAD_2          333
#define M_DRIVER_DEAD_3          334
#define M_FAILED_CREATE_FLAG     335
#define M_CREATED_FLAGFILE       336
#define M_THIS_ADDRESS_LOCKED    337
#define M_BAD_CLEAR_FLAGFILE     338
#define M_CLEARED_FLAGFILE       339
#define M_FAILED_CLEAR_FLAG      340
#define M_BYTE_LIMIT             341
#define M_REFRESH_NODELIST       342
#define M_NO_SIGINT              343
#define M_FILTER                 344
#define M_NEXT_EVENT             345
#define M_EVENT_FLAGS            346
#define M_UNREAD_NETMAIL         347
#define M_NODE_COST              348
#define M_TIME_LIMIT             349
#define M_BAD_QSIZE              350
#define M_BAD_EVENT_ALLOC        351
#define M_BINK_BEGIN             352
#define M_BINK_END               353
#define M_NODE_TO_POLL           354
#define M_POLL_WHOM              355
#define M_NO_COMMON_PROTO        356
#define M_EXT_SPAWN              357
#define M_EXT_RETURN             358
#define M_FORCED_EXIT            359
#define M_CRASH_HOLD_DIR_NORM    360
#define M_CHDN_FLAGS             361
#define M_EMSI_METHOD            362
#define M_EMSI_END               363
#define M_EMSI_PROC_NODE         364
#define M_MAXFILE_SCANNING       365
#define M_MAX_SECURITY_MISMATCH  366
#define M_EMXMIT                 367
#define M_EMRCPT                 368
#define M_EMWAIT                 369
#define M_EMRECV                 370
#define M_EMSEND                 371
#define M_EMSHORT                372
#define M_EMSTART                373
#define M_EXIT_FAX               374
#define M_ZOOM_WAIT              375
#define M_ZOOM_HEADER            376
#define M_ZOOM_TITLE             377
#define M_NODE_BUSY              378
#define M_ZOOM_CHANGE            379
#define M_ZOOM_STOP              380
#define M_ZOOM_DELETE            381
#define M_ZOOM_POLL              382
#define M_ZOOM_DELREQ            383
#define M_ZOOM_DESTINATION       384
#define M_ZOOM_APPEND            385
#define M_ZOOM_RENAME            386
#define M_ZOOM_ERRAPP            387
#define M_ZOOM_DELCOUNT          388
#define M_ZOOM_NOSEND            389
#define M_ZOOM_ERRNOSEND         390
#define M_ZOOM_POLLADDR          391
#define M_ZOOM_ERRCLO            392
#define M_ZOOM_CLO               393
#define M_ZOOM_ERRREQ            394
#define M_ZOOM_DEL_REQ           395
#define M_ZOOM_NEWADDR           396
#define M_ZOOM_MAIL_ATT          397
#define M_ZOOM_REQ_FIL           398
#define M_ZOOM_MAIL_PKT          399
#define M_GET_FLAVOR             400
#define M_SEND_FLAVOR            401
#define M_GET_MORE               402
#define M_SEND_MORE              403
#define M_ZOOM_HELP              404	/* 7 lines */
#define M_NO_COSTFILE            411
#define M_BYTE_SUMMARY           412
#define M_COST_SUMMARY           413
#define M_REC_REQ_AS             414
#define M_HYDRA_AUTO_STARTED     415
#define M_HYDRA_AUTO_FINISHED    416
#define M_START_EXTMAIL          417
#define M_END_EXTMAIL            418
#define M_SHELL_FAX              419
#define M_SHELL_COMPRESSED       420
#define M_SHELL_AFTER_EXTENT     421
#define M_SHELL_AFTER_MAIL       422
#define M_START_ERRLVL_SESSION   423
#define M_RETURN_ERRLVL_SHELL    424
#define M_SQUISH_OPENERR         425
#define M_SQUISH_SEEKERR         426
#define M_SQUISH_READERR         427
#define M_SQUISH_TRASHED_HDR     428
#define M_EVENT_SHELL            429
#define M_BAD_ERRLEVELSHELLNUM   430
#define M_DIALING_ALTNUM         431
#define M_ALTNUM_NO_PRIMARY      432
#define M_ALTNUM_NO_ALTERNATE    433
#define M_FORCED_SHELL           434
/*
 * Easy way to test language file:
 * Always insert new messages before this one and bump his number.
 * Then startup Bink WITHOUT serial in binkley.cfg, and if you see
 * (UNREGISTERED) on the screen, you still have it OK.
 */

#define M_UNREGISTERED           435

/*
 * This last define should be one more than the last message number.
 * Always update this last line when you add or subtract messages!
 */

#define X_TOTAL_MSGS             436
